import arcpy, os

LTBU = arcpy.GetParameterAsText(0)
REF = arcpy.GetParameterAsText(1)
Result_Step_A = "Result_Step_A"

arcpy.env.XYTolerance = ".001 Meters"
if arcpy.GetParameter(3)== 1:
    arcpy.env.overwriteOutput = 1
else:
    arcpy.env.overwriteOutput = 0

arcpy.Select_analysis(LTBU,"LTBU_Select")
arcpy.Select_analysis(REF,"REF_Select")
arcpy.AddField_management("LTBU_Select","x_mb_x","LONG")
arcpy.CalculateField_management("LTBU_Select","x_mb_x","autoIncrement()", "PYTHON", "rec=0 \\ndef autoIncrement(): \\n global rec \\n pStart = 1  \\n pInterval = 1 \\n if (rec == 0):  \\n  rec = pStart  \\n else:  \\n  rec += pInterval  \\n return rec")

arcpy.MakeFeatureLayer_management(REF,"REF_LAYER")
arcpy.SelectLayerByLocation_management("REF_LAYER", "INTERSECT", "LTBU_Select", "", "NEW_SELECTION")
arcpy.Union_analysis("LTBU_Select;REF_LAYER", "REF_LTBU_Union", "ALL",".05 Meters","NO_GAPS")
arcpy.MultipartToSinglepart_management("REF_LTBU_Union","x_Result_Step_A_mb_x")

arcpy.AddField_management("x_Result_Step_A_mb_x","x_mb_id_x","LONG")
arcpy.CalculateField_management("x_Result_Step_A_mb_x","x_mb_id_x","autoIncrement()", "PYTHON", "rec=0 \\ndef autoIncrement(): \\n global rec \\n pStart = 1  \\n pInterval = 1 \\n if (rec == 0):  \\n  rec = pStart  \\n else:  \\n  rec += pInterval  \\n return rec")

arcpy.MinimumBoundingGeometry_management("x_Result_Step_A_mb_x", "Result_Step_A_Bound", "RECTANGLE_BY_AREA", "NONE", "", "MBG_FIELDS")
arcpy.JoinField_management("x_Result_Step_A_mb_x", "x_mb_id_x", "Result_Step_A_Bound", "x_mb_id_x", "MBG_Width;MBG_Length")
arcpy.MakeFeatureLayer_management("x_Result_Step_A_mb_x","x_Result_Step_A_mb_x_LAYER")
arcpy.AddField_management("x_Result_Step_A_mb_x_LAYER","x_mb_ratio_x","DOUBLE")
arcpy.SelectLayerByAttribute_management("x_Result_Step_A_mb_x_LAYER", "NEW_SELECTION", "MBG_Length <> 0")
arcpy.CalculateField_management("x_Result_Step_A_mb_x_LAYER", "x_mb_ratio_x", "[MBG_Width] / [MBG_Length]", "VB", "")
arcpy.SelectLayerByAttribute_management("x_Result_Step_A_mb_x_LAYER", "NEW_SELECTION", "MBG_Length * MBG_Width  <> 0")
arcpy.AddField_management("x_Result_Step_A_mb_x_LAYER","x_mb_pctcover_x","DOUBLE")
arcpy.CalculateField_management("x_Result_Step_A_mb_x_LAYER", "x_mb_pctcover_x", "[Shape_Area] /([MBG_Width] * [MBG_Length])", "VB", "")

arcpy.AddField_management("x_Result_Step_A_mb_x","ThinRating","TEXT")
arcpy.CalculateField_management("x_Result_Step_A_mb_x", "ThinRating", "\"HIGH\"", "VB", "")
arcpy.MakeFeatureLayer_management("x_Result_Step_A_mb_x","Result_Step_A_LAYER")
arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER", "NEW_SELECTION", "x_mb_ratio_x > .1")
arcpy.CalculateField_management("Result_Step_A_LAYER", "ThinRating", "\"MEDIUM\"", "VB", "")
arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER", "NEW_SELECTION", "x_mb_ratio_x > .35")
arcpy.CalculateField_management("Result_Step_A_LAYER", "ThinRating", "\"LOW\"", "VB", "")
arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER", "NEW_SELECTION", "ThinRating in ('MEDIUM', 'LOW') AND x_mb_pctcover_x < .2")
arcpy.CalculateField_management("Result_Step_A_LAYER", "ThinRating", "\"HIGH\"", "VB", "")
arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER", "NEW_SELECTION", "(ThinRating = 'LOW')  AND (x_mb_pctcover_x >= .2) AND  (x_mb_pctcover_x <= .5 )")
arcpy.CalculateField_management("Result_Step_A_LAYER", "ThinRating", "\"MEDIUM\"", "VB", "")
arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER", "NEW_SELECTION", "ThinRating = 'MEDIUM' AND x_mb_pctcover_x > .7")
arcpy.CalculateField_management("Result_Step_A_LAYER", "ThinRating", "\"LOW\"", "VB", "")
arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER", "CLEAR_SELECTION", "")
arcpy.DeleteField_management("Result_Step_A_LAYER", "MBG_Width;MBG_Length;x_mb_pctcover_x")

arcpy.SpatialJoin_analysis("x_Result_Step_A_mb_x", "x_Result_Step_A_mb_x", "Result_Step_A_SJ", "JOIN_ONE_TO_ONE", "KEEP_ALL", "", "SHARE_A_LINE_SEGMENT_WITH", "", "")
arcpy.AddField_management("Result_Step_A_SJ","NumAdj","SHORT")
arcpy.CalculateField_management("Result_Step_A_SJ", "NumAdj", "[Join_Count] - 1", "VB", "")
arcpy.JoinField_management("Result_Step_A_LAYER", "OBJECTID", "Result_Step_A_SJ", "TARGET_FID", "NumAdj")


arcpy.Select_analysis("x_Result_Step_A_mb_x",Result_Step_A)

for DELETES in ("REF_LTBU_Union","Result_Step_A_Bound","Result_Step_A_SJ","Result_Step_A_LAYER","x_Result_Step_A_mb_x"):
    arcpy.Delete_management(DELETES)