import arcpy, os

Result_Step_A = "Result_Step_A"
Final_Output = arcpy.GetParameterAsText(0)
totalRSAcount = arcpy.GetCount_management(arcpy.Describe(Result_Step_A).catalogpath)
selectedRSAcount = arcpy.GetCount_management(Result_Step_A)

if totalRSAcount.getOutput(0) == selectedRSAcount.getOutput(0):
    arcpy.AddWarning("Please make a selection within the Result Step A layer")

else:
    #Copy Slivers
    arcpy.Select_analysis(Result_Step_A,"Sliver_Set")
    arcpy.MakeFeatureLayer_management("Result_Step_A","Result_Step_A_LAYER_Delete")
    arcpy.SelectLayerByLocation_management("Result_Step_A_LAYER_Delete","WITHIN", "REF_Select", "", "NEW_SELECTION")
    arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER_Delete", "SWITCH_SELECTION", "")
    arcpy.DeleteFeatures_management("Result_Step_A_LAYER_Delete")

    #Eliminate
    arcpy.Eliminate_management(Result_Step_A, "Eliminate_1", "LENGTH", "", "")
    arcpy.RepairGeometry_management("Eliminate_1", "DELETE_NULL")

    #Recreate Slivers / Delete Those Outside Reference
    arcpy.Union_analysis("Eliminate_1;REF_Select", "Union_S1", "ALL", "", "GAPS")
    arcpy.RepairGeometry_management("Union_S1", "DELETE_NULL")
    arcpy.MultipartToSinglepart_management("Union_S1","Result_Step_Da")

    arcpy.MakeFeatureLayer_management("Result_Step_Da","Result_Step_Da_LAYER_Selected")
    arcpy.SelectLayerByLocation_management("Result_Step_Da_LAYER_Selected","WITHIN", "Sliver_Set", "", "NEW_SELECTION")
    arcpy.SelectLayerByAttribute_management("Result_Step_Da_LAYER_Selected", "REMOVE_FROM_SELECTION", "NumAdj =1")

    #Eliminate Again
    arcpy.Eliminate_management("Result_Step_Da_LAYER_Selected", "Eliminate_2", "LENGTH", "", "")
    arcpy.RepairGeometry_management("Eliminate_2", "DELETE_NULL")

    #Recreate and Select Slivers Again
    arcpy.Union_analysis("Eliminate_2;REF_Select", "Union_S2", "ALL", "", "GAPS")
    arcpy.RepairGeometry_management("Union_S2", "DELETE_NULL")
    arcpy.MultipartToSinglepart_management("Union_S2","Result_Step_Db")

    arcpy.MakeFeatureLayer_management("Result_Step_Db","Result_Step_D_LAYER_Selected")
    arcpy.SelectLayerByLocation_management("Result_Step_D_LAYER_Selected","WITHIN", "Sliver_Set", "", "NEW_SELECTION")
    arcpy.SelectLayerByAttribute_management("Result_Step_D_LAYER_Selected", "REMOVE_FROM_SELECTION", "NumAdj =1")

    #Alt Eliminate##
    arcpy.AddField_management("Result_Step_Db","x_id_x","LONG")
    arcpy.CalculateField_management("Result_Step_Db","x_id_x","autoIncrement()", "PYTHON", "rec=0 \\ndef autoIncrement(): \\n global rec \\n pStart = 1  \\n pInterval = 1 \\n if (rec == 0):  \\n  rec = pStart  \\n else:  \\n  rec += pInterval  \\n return rec")
    arcpy.PolygonToLine_management("Result_Step_D_LAYER_Selected","Sliver_Lines","IDENTIFY_NEIGHBORS")
    arcpy.SplitLine_management("Sliver_Lines","Sliver_Lines_Split")
    arcpy.SpatialJoin_analysis("Sliver_Lines_Split","Result_Step_Db","Lines_SJ","JOIN_ONE_TO_MANY","KEEP_ALL","x_id_x \"x_id_x\" true true false 0 Long 0 0 ,First,#,%workspace%\\Result_Step_Db,x_id_x,-1,-1","SHARE_A_LINE_SEGMENT_WITH")
    arcpy.Dissolve_management("Lines_SJ","Lines_Dissolve","TARGET_FID",[["x_id_x","MIN"],["x_id_x","MAX"]])
    arcpy.Dissolve_management("Lines_Dissolve","Lines_Dissolve2","MAX_x_id_x;MIN_x_id_x")
    arcpy.AddField_management("Lines_Dissolve2","x_sl_x","DOUBLE")
    arcpy.CalculateField_management("Lines_Dissolve2","x_sl_x","!shape.length@feet!", "PYTHON")
    arcpy.AddField_management("Lines_Dissolve2","x_ss_x","DOUBLE")
    arcpy.CalculateField_management("Lines_Dissolve2","x_ss_x","autoIncrement()", "PYTHON", "rec=0 \\ndef autoIncrement(): \\n global rec \\n pStart = 1  \\n pInterval = 1 \\n if (rec == 0):  \\n  rec = pStart  \\n else:  \\n  rec += pInterval  \\n return rec")
    arcpy.SpatialJoin_analysis("Result_Step_D_LAYER_Selected","Lines_Dissolve2","Lines_SJ2","JOIN_ONE_TO_MANY","KEEP_ALL","x_id_x \"x_id_x\" true true false 0 Long 0 0 ,First,#,%workspace%\\Result_Step_Db,x_id_x,-1,-1;x_ss_x \"x_ss_x\" true true false 0 Long 0 0 ,First,#,%workspace%\\Lines_Dissolve2,x_ss_x,-1,-1;x_sl_x \"x_sl_x\" true true false 0 Double 0 0 ,First,#,%workspace%\\Lines_Dissolve2,x_sl_x,-1,-1","SHARE_A_LINE_SEGMENT_WITH")
    arcpy.AddField_management("Lines_SJ2","x_idss_x","TEXT","","",600)
    arcpy.CalculateField_management("Lines_SJ2","x_idss_x","[x_id_x] & \"_\" & [x_sl_x]")

        #Find Largest Side and remove from list
    arcpy.Statistics_analysis("Lines_SJ2","Stats1",[["x_sl_x","MAX"]],"x_id_x")
    arcpy.AddField_management("Stats1","x_idss_x","TEXT","","",600)
    arcpy.CalculateField_management("Stats1","x_idss_x","[x_id_x] & \"_\" & [MAX_x_sl_x]")
    arcpy.MakeFeatureLayer_management("Lines_SJ2","Lines_SJ2_LAYER")
    arcpy.AddJoin_management("Lines_SJ2_LAYER","x_idss_x","Stats1","x_idss_x","KEEP_COMMON")
    arcpy.SelectLayerByAttribute_management("Lines_SJ2_LAYER", "NEW_SELECTION", "Lines_SJ2.x_idss_x <> '1'")
    arcpy.DeleteFeatures_management("Lines_SJ2_LAYER")
    arcpy.RemoveJoin_management("Lines_SJ2_LAYER")
       #Find Second Largest Side and remove all others from list
    arcpy.Statistics_analysis("Lines_SJ2","Stats2",[["x_sl_x","MAX"]],"x_id_x")
    arcpy.AddField_management("Stats2","x_idss_x","TEXT","","",600)
    arcpy.CalculateField_management("Stats2","x_idss_x","[x_id_x] & \"_\" & [MAX_x_sl_x]")
    arcpy.AddJoin_management("Lines_SJ2_LAYER","x_idss_x","Stats2","x_idss_x","KEEP_ALL")
    arcpy.SelectLayerByAttribute_management("Lines_SJ2_LAYER", "NEW_SELECTION", "Stats2.FREQUENCY > -1")
    arcpy.SelectLayerByAttribute_management("Lines_SJ2_LAYER", "SWITCH_SELECTION", "")
    arcpy.DeleteFeatures_management("Lines_SJ2_LAYER")
    arcpy.RemoveJoin_management("Lines_SJ2_LAYER")
       #Find Neighbor creating Second Largest Side
    arcpy.JoinField_management("Lines_SJ2_LAYER","x_ss_x","Lines_Dissolve2","x_ss_x","MIN_x_id_x;MAX_x_id_x")
    arcpy.AddField_management("Lines_SJ2_LAYER","x_join_x","LONG")
    arcpy.SelectLayerByAttribute_management("Lines_SJ2_LAYER", "NEW_SELECTION", "x_id_x = MIN_x_id_x")
    arcpy.CalculateField_management("Lines_SJ2_LAYER","x_join_x","[MAX_x_id_x]")
    arcpy.SelectLayerByAttribute_management("Lines_SJ2_LAYER", "NEW_SELECTION", "x_id_x = MAX_x_id_x")
    arcpy.CalculateField_management("Lines_SJ2_LAYER","x_join_x","[MIN_x_id_x]")
    arcpy.SelectLayerByAttribute_management("Lines_SJ2_LAYER", "CLEAR_SELECTION", "")
    arcpy.JoinField_management("Lines_SJ2_LAYER","x_join_x","Result_Step_Db","x_id_x","x_mb_x")
       #Merge sliver into neighbor on its Second Largest Side
    arcpy.AddField_management("Result_Step_Db","x_dissolve_x","LONG")
    arcpy.MakeFeatureLayer_management("Result_Step_Db","Result_Step_D_LAYER")
    arcpy.AddJoin_management("Result_Step_D_LAYER","x_id_x","Lines_SJ2","x_id_x","KEEP_COMMON")
    arcpy.CalculateField_management("Result_Step_D_LAYER","Result_Step_Db.x_dissolve_x","[Lines_SJ2.x_join_x]")
    arcpy.CalculateField_management("Result_Step_D_LAYER","Result_Step_Db.x_mb_x","[Lines_SJ2.x_mb_x]")
    arcpy.RemoveJoin_management("Result_Step_D_LAYER")
    arcpy.Dissolve_management("Result_Step_D_LAYER","Result_Step_Dc","x_dissolve_x;x_mb_x")
    arcpy.RepairGeometry_management("Result_Step_Dc", "DELETE_NULL")

    #Delete Features outside the Reference Layer and the Layer to be Updated
    arcpy.MakeFeatureLayer_management("Result_Step_Dc","Result_Step_Dc_LAYER")
    arcpy.SelectLayerByLocation_management("Result_Step_Dc_LAYER","WITHIN", "Sliver_Set", "", "NEW_SELECTION")
    arcpy.MakeFeatureLayer_management("Result_Step_Dc_LAYER","Result_Step_Dc_LAYER_Selected")
    arcpy.SelectLayerByLocation_management("Result_Step_Dc_LAYER_Selected","WITHIN_CLEMENTINI", "REF_Select", "", "SUBSET_SELECTION")
    arcpy.SelectLayerByAttribute_management("Result_Step_Dc_LAYER_Selected", "SWITCH_SELECTION", "")
    arcpy.DeleteFeatures_management("Result_Step_Dc_LAYER_Selected")
    arcpy.SelectLayerByAttribute_management("Result_Step_Dc_LAYER", "CLEAR_SELECTION", "")

    arcpy.Dissolve_management("Result_Step_Dc_LAYER","Pre_Final_Output","x_mb_x")
    arcpy.RepairGeometry_management("Pre_Final_Output", "DELETE_NULL")
    arcpy.MakeFeatureLayer_management("Pre_Final_Output","Pre_Final_Output_LAYER")

    arcpy.SelectLayerByAttribute_management("Pre_Final_Output_LAYER","NEW_SELECTION", "x_mb_x = 0 OR x_mb_x is null")
    arcpy.DeleteFeatures_management("Pre_Final_Output_LAYER")

    #Reestablish field information from Copy saved in Step A
    arcpy.JoinField_management("Pre_Final_Output","x_mb_x","LTBU_Select","x_mb_x")
    arcpy.DeleteFeatures_management("LTBU_Select")
    arcpy.Append_management("Pre_Final_Output","LTBU_Select","NO_TEST")

    #ReRun Step A
    arcpy.MakeFeatureLayer_management("Ref_Select","REF_LAYER")
    arcpy.SelectLayerByLocation_management("REF_LAYER", "INTERSECT", "LTBU_Select", "", "NEW_SELECTION")
    arcpy.Union_analysis("LTBU_Select;REF_LAYER", "REF_LTBU_Union", "ALL",".05 Meters","NO_GAPS")
    arcpy.MultipartToSinglepart_management("REF_LTBU_Union","x_Result_Step_A_mb_x")

    arcpy.AddField_management("x_Result_Step_A_mb_x","x_mb_id_x","LONG")
    arcpy.CalculateField_management("x_Result_Step_A_mb_x","x_mb_id_x","autoIncrement()", "PYTHON", "rec=0 \\ndef autoIncrement(): \\n global rec \\n pStart = 1  \\n pInterval = 1 \\n if (rec == 0):  \\n  rec = pStart  \\n else:  \\n  rec += pInterval  \\n return rec")

    arcpy.MinimumBoundingGeometry_management("x_Result_Step_A_mb_x", "Result_Step_A_Bound", "RECTANGLE_BY_AREA", "NONE", "", "MBG_FIELDS")
    arcpy.JoinField_management("x_Result_Step_A_mb_x", "x_mb_id_x", "Result_Step_A_Bound", "x_mb_id_x", "MBG_Width;MBG_Length")
    arcpy.MakeFeatureLayer_management("x_Result_Step_A_mb_x","x_Result_Step_A_mb_x_LAYER")
    arcpy.AddField_management("x_Result_Step_A_mb_x_LAYER","x_mb_ratio_x","DOUBLE")
    arcpy.SelectLayerByAttribute_management("x_Result_Step_A_mb_x_LAYER", "NEW_SELECTION", "MBG_Length <> 0")
    arcpy.CalculateField_management("x_Result_Step_A_mb_x_LAYER", "x_mb_ratio_x", "[MBG_Width] / [MBG_Length]", "VB", "")
    arcpy.SelectLayerByAttribute_management("x_Result_Step_A_mb_x_LAYER", "NEW_SELECTION", "MBG_Length * MBG_Width  <> 0")
    arcpy.AddField_management("x_Result_Step_A_mb_x_LAYER","x_mb_pctcover_x","DOUBLE")
    arcpy.CalculateField_management("x_Result_Step_A_mb_x_LAYER", "x_mb_pctcover_x", "[Shape_Area] /([MBG_Width] * [MBG_Length])", "VB", "")

    arcpy.AddField_management("x_Result_Step_A_mb_x","ThinRating","TEXT")
    arcpy.CalculateField_management("x_Result_Step_A_mb_x", "ThinRating", "\"HIGH\"", "VB", "")
    arcpy.MakeFeatureLayer_management("x_Result_Step_A_mb_x","Result_Step_A_LAYER")
    arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER", "NEW_SELECTION", "x_mb_ratio_x > .1")
    arcpy.CalculateField_management("Result_Step_A_LAYER", "ThinRating", "\"MEDIUM\"", "VB", "")
    arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER", "NEW_SELECTION", "x_mb_ratio_x > .35")
    arcpy.CalculateField_management("Result_Step_A_LAYER", "ThinRating", "\"LOW\"", "VB", "")
    arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER", "NEW_SELECTION", "ThinRating in ('MEDIUM', 'LOW') AND x_mb_pctcover_x < .2")
    arcpy.CalculateField_management("Result_Step_A_LAYER", "ThinRating", "\"HIGH\"", "VB", "")
    arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER", "NEW_SELECTION", "(ThinRating = 'LOW')  AND (x_mb_pctcover_x >= .2) AND  (x_mb_pctcover_x <= .5 )")
    arcpy.CalculateField_management("Result_Step_A_LAYER", "ThinRating", "\"MEDIUM\"", "VB", "")
    arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER", "NEW_SELECTION", "ThinRating = 'MEDIUM' AND x_mb_pctcover_x > .7")
    arcpy.CalculateField_management("Result_Step_A_LAYER", "ThinRating", "\"LOW\"", "VB", "")
    arcpy.SelectLayerByAttribute_management("Result_Step_A_LAYER", "CLEAR_SELECTION", "")
    arcpy.DeleteField_management("Result_Step_A_LAYER", "MBG_Width;MBG_Length;x_mb_pctcover_x")

    arcpy.SpatialJoin_analysis("x_Result_Step_A_mb_x", "x_Result_Step_A_mb_x", "Result_Step_A_SJ", "JOIN_ONE_TO_ONE", "KEEP_ALL", "", "SHARE_A_LINE_SEGMENT_WITH", "", "")
    arcpy.AddField_management("Result_Step_A_SJ","NumAdj","SHORT")
    arcpy.CalculateField_management("Result_Step_A_SJ", "NumAdj", "[Join_Count] - 1", "VB", "")
    arcpy.JoinField_management("Result_Step_A_LAYER", "OBJECTID", "Result_Step_A_SJ", "TARGET_FID", "NumAdj")

    arcpy.Select_analysis("x_Result_Step_A_mb_x",Final_Output)

    for DELETES in ("REF_LTBU_Union","Result_Step_A_Bound","Result_Step_A_SJ","x_Result_Step_A_mb_x","Pre_Final_Output","Eliminate_1","Eliminate_2","Lines_Dissolve","Lines_Dissolve2","Lines_SJ","Lines_SJ2","Result_Step_Db","Result_Step_Da","Result_Step_Dc","Sliver_Lines","Sliver_Lines_Split","Sliver_Set","Stats1","Stats2","Union_S2","Union_S1"):
        arcpy.Delete_management(DELETES)