import arcpy, os

Result_Step_D = "Result_Step_D"
Final_Output = arcpy.GetParameterAsText(0)

totalRSAcount = arcpy.GetCount_management(arcpy.Describe(Result_Step_D).catalogpath)
selectedRSAcount = arcpy.GetCount_management(Result_Step_D)

if totalRSAcount.getOutput(0) == selectedRSAcount.getOutput(0):
    arcpy.Dissolve_management("Result_Step_D","Pre_Final_Output","x_mb_x")
    arcpy.RepairGeometry_management("Pre_Final_Output", "DELETE_NULL")
    arcpy.MakeFeatureLayer_management("Pre_Final_Output","Pre_Final_Output_LAYER")
    arcpy.SelectLayerByAttribute_management("Pre_Final_Output_LAYER","NEW_SELECTION", "x_mb_x = 0 OR x_mb_x is null")
    arcpy.DeleteFeatures_management("Pre_Final_Output_LAYER")
    arcpy.JoinField_management("Pre_Final_Output","x_mb_x","LTBU_Select","x_mb_x")
    arcpy.DeleteFeatures_management("LTBU_Select")
    arcpy.Append_management("Pre_Final_Output","LTBU_Select","NO_TEST")
    arcpy.DeleteField_management("LTBU_Select","x_mb_x")
    arcpy.Select_analysis("LTBU_Select", Final_Output)

    arcpy.Delete_management("Pre_Final_Output")

else:

    #Copy Slivers
    arcpy.AddField_management(arcpy.Describe(Result_Step_D).catalogpath,"x_id_x","LONG")
    arcpy.CalculateField_management(arcpy.Describe(Result_Step_D).catalogpath,"x_id_x","autoIncrement()", "PYTHON", "rec=0 \\ndef autoIncrement(): \\n global rec \\n pStart = 1  \\n pInterval = 1 \\n if (rec == 0):  \\n  rec = pStart  \\n else:  \\n  rec += pInterval  \\n return rec")
    arcpy.Select_analysis(Result_Step_D,"Sliver_Set")
    arcpy.SelectLayerByAttribute_management(Result_Step_D, "SWITCH_SELECTION", "")
    arcpy.Select_analysis(Result_Step_D,"Non_Sliver_Set")
    arcpy.SelectLayerByAttribute_management(Result_Step_D, "CLEAR_SELECTION", "")

    #Alt Eliminate##
    arcpy.PolygonToLine_management("Sliver_Set","Sliver_Lines","IDENTIFY_NEIGHBORS")
    arcpy.SplitLine_management("Sliver_Lines","Sliver_Lines_Split")
    arcpy.SpatialJoin_analysis("Sliver_Lines_Split",arcpy.Describe(Result_Step_D).catalogpath,"Lines_SJ","JOIN_ONE_TO_MANY","KEEP_ALL","x_id_x \"x_id_x\" true true false 0 Long 0 0 ,First,#,%workspace%\\Result_Step_D,x_id_x,-1,-1","SHARE_A_LINE_SEGMENT_WITH")
    arcpy.Dissolve_management("Lines_SJ","Lines_Dissolve","TARGET_FID",[["x_id_x","MIN"],["x_id_x","MAX"]])
    arcpy.Dissolve_management("Lines_Dissolve","Lines_Dissolve2","MAX_x_id_x;MIN_x_id_x")
    arcpy.AddField_management("Lines_Dissolve2","x_sl_x","DOUBLE")
    arcpy.CalculateField_management("Lines_Dissolve2","x_sl_x","!shape.length@feet!", "PYTHON")
    arcpy.AddField_management("Lines_Dissolve2","x_ss_x","DOUBLE")
    arcpy.CalculateField_management("Lines_Dissolve2","x_ss_x","autoIncrement()", "PYTHON", "rec=0 \\ndef autoIncrement(): \\n global rec \\n pStart = 1  \\n pInterval = 1 \\n if (rec == 0):  \\n  rec = pStart  \\n else:  \\n  rec += pInterval  \\n return rec")
    arcpy.SpatialJoin_analysis("Sliver_Set","Lines_Dissolve2","Lines_SJ2","JOIN_ONE_TO_MANY","KEEP_ALL","x_id_x \"x_id_x\" true true false 0 Long 0 0 ,First,#,%workspace%\\Sliver_Set,x_id_x,-1,-1;x_ss_x \"x_ss_x\" true true false 0 Long 0 0 ,First,#,%workspace%\\Lines_Dissolve2,x_ss_x,-1,-1;x_sl_x \"x_sl_x\" true true false 0 Double 0 0 ,First,#,%workspace%\\Lines_Dissolve2,x_sl_x,-1,-1","SHARE_A_LINE_SEGMENT_WITH")
    arcpy.AddField_management("Lines_SJ2","x_idss_x","TEXT","","",600)
    arcpy.CalculateField_management("Lines_SJ2","x_idss_x","[x_id_x] & \"_\" & [x_sl_x]")

        #Find Largest Side and remove from list
    arcpy.Statistics_analysis("Lines_SJ2","Stats1",[["x_sl_x","MAX"]],"x_id_x")
    arcpy.AddField_management("Stats1","x_idss_x","TEXT","","",600)
    arcpy.CalculateField_management("Stats1","x_idss_x","[x_id_x] & \"_\" & [MAX_x_sl_x]")
    arcpy.MakeFeatureLayer_management("Lines_SJ2","Lines_SJ2_LAYER")
    arcpy.AddJoin_management("Lines_SJ2_LAYER","x_idss_x","Stats1","x_idss_x","KEEP_COMMON")
    arcpy.SelectLayerByAttribute_management("Lines_SJ2_LAYER", "NEW_SELECTION", "Lines_SJ2.x_idss_x <> '1'")
    arcpy.DeleteFeatures_management("Lines_SJ2_LAYER")
    arcpy.RemoveJoin_management("Lines_SJ2_LAYER")

       #Find Second Largest Side and remove all others from list
    arcpy.Statistics_analysis("Lines_SJ2","Stats2",[["x_sl_x","MAX"]],"x_id_x")
    arcpy.AddField_management("Stats2","x_idss_x","TEXT","","",600)
    arcpy.CalculateField_management("Stats2","x_idss_x","[x_id_x] & \"_\" & [MAX_x_sl_x]")
    arcpy.AddJoin_management("Lines_SJ2_LAYER","x_idss_x","Stats2","x_idss_x","KEEP_ALL")
    arcpy.SelectLayerByAttribute_management("Lines_SJ2_LAYER", "NEW_SELECTION", "Stats2.FREQUENCY > -1")
    arcpy.SelectLayerByAttribute_management("Lines_SJ2_LAYER", "SWITCH_SELECTION", "")
    arcpy.DeleteFeatures_management("Lines_SJ2_LAYER")
    arcpy.RemoveJoin_management("Lines_SJ2_LAYER")

       #Find Neighbor creating Second Largest Side
    arcpy.JoinField_management("Lines_SJ2_LAYER","x_ss_x","Lines_Dissolve2","x_ss_x","MIN_x_id_x;MAX_x_id_x")
    arcpy.AddField_management("Lines_SJ2_LAYER","x_join_x","LONG")
    arcpy.SelectLayerByAttribute_management("Lines_SJ2_LAYER", "NEW_SELECTION", "x_id_x = MIN_x_id_x")
    arcpy.CalculateField_management("Lines_SJ2_LAYER","x_join_x","[MAX_x_id_x]")
    arcpy.SelectLayerByAttribute_management("Lines_SJ2_LAYER", "NEW_SELECTION", "x_id_x = MAX_x_id_x")
    arcpy.CalculateField_management("Lines_SJ2_LAYER","x_join_x","[MIN_x_id_x]")
    arcpy.SelectLayerByAttribute_management("Lines_SJ2_LAYER", "CLEAR_SELECTION", "")
    arcpy.JoinField_management("Result_Step_D","x_id_x","Lines_SJ2_LAYER","x_id_x","x_join_x")
    arcpy.AddField_management("Result_Step_D","x_dissolve_x","LONG")
    arcpy.CalculateField_management("Result_Step_D","x_dissolve_x","[x_id_x]")
    arcpy.SelectLayerByAttribute_management("Result_Step_D", "NEW_SELECTION", "x_join_x is not null")
    arcpy.CalculateField_management("Result_Step_D","x_dissolve_x","[x_join_x]")
    arcpy.SelectLayerByAttribute_management("Result_Step_D", "CLEAR_SELECTION","")
    arcpy.Dissolve_management("Result_Step_D","Result_Step_D1","x_dissolve_x")
    arcpy.JoinField_management("Result_Step_D1","x_dissolve_x","Non_Sliver_Set","x_id_x","x_mb_x")
    arcpy.RepairGeometry_management("Result_Step_D1", "DELETE_NULL")

    #Recreate and Select Slivers
    arcpy.Union_analysis("Result_Step_D1;REF_Select", "Union_S1", "ALL", "", "GAPS")
    arcpy.RepairGeometry_management("Union_S1", "DELETE_NULL")
    arcpy.MultipartToSinglepart_management("Union_S1","Result_Union_S1")

    arcpy.MakeFeatureLayer_management("Result_Union_S1","Result_Union_S1_LAYER_Selected")
    arcpy.SelectLayerByLocation_management("Result_Union_S1_LAYER_Selected","WITHIN", "Sliver_Set", "", "NEW_SELECTION")

    #Eliminate
    arcpy.Eliminate_management("Result_Union_S1_LAYER_Selected", "Eliminate_1", "LENGTH", "", "")
    arcpy.RepairGeometry_management("Eliminate_1", "DELETE_NULL")

    #Recreate and Select Slivers Again
    arcpy.Union_analysis("Eliminate_1;REF_Select", "Union_S2", "ALL", "", "GAPS")
    arcpy.RepairGeometry_management("Union_S2", "DELETE_NULL")
    arcpy.MultipartToSinglepart_management("Union_S1","Result_Union_S2")

    arcpy.MakeFeatureLayer_management("Result_Union_S2","Result_Union_S2_LAYER_Selected")
    arcpy.SelectLayerByLocation_management("Result_Union_S2_LAYER_Selected","WITHIN", "Sliver_Set", "", "NEW_SELECTION")

    #Eliminate Again
    arcpy.Eliminate_management("Result_Union_S2_LAYER_Selected", "Eliminate_2", "LENGTH", "", "")
    arcpy.RepairGeometry_management("Eliminate_2", "DELETE_NULL")

    #Delete Features outside the Reference Layer and the Layer to be Updated
    arcpy.MakeFeatureLayer_management("Eliminate_2","Result_Step_E_LAYER")
    arcpy.SelectLayerByLocation_management("Result_Step_E_LAYER","WITHIN", "Sliver_Set", "", "NEW_SELECTION")
    arcpy.MakeFeatureLayer_management("Result_Step_E_LAYER","Result_Step_E_LAYER_Selected")
    arcpy.SelectLayerByLocation_management("Result_Step_E_LAYER_Selected","WITHIN_CLEMENTINI", "REF_Select", "", "SUBSET_SELECTION")
    arcpy.SelectLayerByAttribute_management("Result_Step_E_LAYER_Selected", "SWITCH_SELECTION", "")
    arcpy.DeleteFeatures_management("Result_Step_E_LAYER_Selected")
    arcpy.SelectLayerByAttribute_management("Result_Step_E_LAYER", "CLEAR_SELECTION", "")

    arcpy.Dissolve_management("Result_Step_E_LAYER","Pre_Final_Output","x_mb_x")
    arcpy.RepairGeometry_management("Pre_Final_Output", "DELETE_NULL")
    arcpy.MakeFeatureLayer_management("Pre_Final_Output","Pre_Final_Output_LAYER")

    arcpy.SelectLayerByAttribute_management("Pre_Final_Output_LAYER","NEW_SELECTION", "x_mb_x = 0 OR x_mb_x is null")
    arcpy.DeleteFeatures_management("Pre_Final_Output_LAYER")

    #Reestablish field information from Copy saved in Step A
    arcpy.JoinField_management("Pre_Final_Output","x_mb_x","LTBU_Select","x_mb_x")
    arcpy.DeleteFeatures_management("LTBU_Select")
    arcpy.Append_management("Pre_Final_Output","LTBU_Select","NO_TEST")
    arcpy.DeleteField_management("LTBU_Select","x_mb_x")
    arcpy.Select_analysis("LTBU_Select", Final_Output)

    for DELETES in ("Non_Sliver_Set","Pre_Final_Output","Eliminate_1","Eliminate_2","Lines_Dissolve","Lines_Dissolve2","Lines_SJ","Lines_SJ2","Result_Union_S1","Result_Union_S2","Result_Step_D1","Sliver_Lines","Sliver_Lines_Split","Sliver_Set","Stats1","Stats2","Union_S2","Union_S1"):
        arcpy.Delete_management(DELETES)